﻿/*
   Copyright 2015 University of Washington

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

using System;
using System.ComponentModel;
using System.Windows.Forms;
using CometUI.SharedUI;

namespace CometUI.ViewResults
{
    public partial class ViewResultsProgressDlg : ProgressDlg
    {
        public ViewResultsProgressDlg(BackgroundWorker backgroundWorker)
            : base(backgroundWorker)
        {
            InitializeComponent();

            progressStatusMessageTimer.Interval = 10;
            progressStatusMessageTimer.Tick += ProgressStatusMessageTimerTick;
            progressStatusMessageTimer.Start();

            FormClosing += ViewResultsProgressDlgClosing;
        }

        private void ProgressStatusMessageTimerTick(object sender, EventArgs e)
        {
            UpdateStatusText();
        }

        private void UpdateStatusText()
        {
            const string newStatusText = "Loading results...";
            UpdateStatusText(newStatusText);
        }

        private void ViewResultsProgressDlgClosing(object sender, FormClosingEventArgs e)
        {
            progressStatusMessageTimer.Stop();
        }
    }
}
